// Web Browser find and Web Document parsing easy program.
// (c) by Denis Kirin for Zarko Gajic.
//mailto: wtwsoft@narod.ru (Free Software for blind)
//Open Source
// Delphi 7, Internet Explorer 6 (5 must work)
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shDocvw, ComCtrls;
//Use shDocvw to access to shell window routine
type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Label1: TLabel;
    Memo1: TMemo;
    Label2: TLabel;
    Memo2: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    TreeView1: TTreeView;
    Label5: TLabel;
    StaticText1: TStaticText;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
// This method enumerate (find) all open Web Browser on system, and
// add URL from found browser to ListBox1

procedure TForm1.Button1Click(Sender: TObject);
var
  ShellWindows: TShellWindows; //ShellWindows class, to access to all Shell Window
  ShellWindowDisp: IDispatch; //Dispatch interface to found shal window
  WebBrowser: IWebbrowser2; //Interface to found web browser
  Count: integer; //counter of shell window
begin
  ListBox1.Clear; //Clear URL list
  ShellWindows := TShellWindows.Create(Self); //Create class
  for Count := 0 to ShellWindows.Count - 1 do //Enumerate all shell window
  begin
    ShellWindowDisp := ShellWindows.Item(Count); //Get Interface to current shell window
    if ShellWindowDisp = nil then Continue; //Interface is present
    ShellWindowDisp.QueryInterface(iWebBrowser2, WebBrowser); //if the Web Browser window
    if WebBrowser.LocationURL = '' then Continue; //The browser is navigate ?
    if Assigned(WebBrowser.Document) then // The Web browser have complite documet ?
      ListBox1.Items.Add(WebBrowser.LocationURL); //Add URL form browser to list
  end;

  ShellWindows.Destroy; //Destroy class
end;

//Find browser with URL from list, and get Document elements from whis browser (if it is pressent)

procedure TForm1.Button2Click(Sender: TObject);
var
  //see Button1Click
  ShellWindows: TShellWindows;
  ShellWindowDisp: IDispatch;
  WebBrowser: IWebbrowser2;
  Document, // Interface to Web Browser Document
    DocElement: Variant; // Interface to Document element(s)
  Count, ElementCount: integer; //Counters
  ElementNode: TTreeNode; //for build Document "ALL" TreeView
begin
  //if not browser URL selected, Exit
  if ListBox1.ItemIndex = -1 then
  begin
    ShowMessage('Select browser first.');
    Exit;
  end;
  //Show "Wait..." label
  Label5.Visible := true;
  //Enumerate shell window, find Web Browser window navigate to select URL
  ShellWindows := TShellWindows.Create(Self);
  for Count := 0 to ShellWindows.Count - 1 do
  begin
    ShellWindowDisp := ShellWindows.Item(Count);
    if ShellWindowDisp = nil then Continue; //Interface is present
    ShellWindowDisp.QueryInterface(iWebBrowser2, WebBrowser); //if the Web Browser window
    if WebBrowser.LocationURL = '' then Continue; //The browser is navigate ?
    //URL is find, Interface is Query -> Break
    if ListBox1.Items[ListBox1.ItemIndex] = WebBrowser.LocationURL then Break;
  end;
  ShellWindows.Destroy;
  //for this application form is friz, but we do that for "Wait..." label show only
  Application.ProcessMessages;
  //Try get Documnet from found web browser
  Document := WebBrowser.Document;
  try
    //Get Document text
    Memo1.Lines.Text := Document.Body.innerText;
    //Get Document html ("View Source" options from Internet Explorer ;)
    Memo2.Lines.Text := Document.Body.innerHTML;
    //Build Documnet "all" TreeView
    //Lock TreeView
    TreeView1.Items.BeginUpdate;
    //Clear old data
    TreeView1.Items.Clear;
    //Enumarate ALL Document elements
    for ElementCount := 0 to Document.All.length - 1 do
    begin
      //Geting from data elements (universal data, it present in ALL elements)
      //Any element type have original data (Forms, Links)

      //Get interface to current Document Element
      DocElement := Document.All.Item(ElementCount);
      //Add Element.TagName to TreeView Root
      ElementNode := TreeView1.Items.Add(nil, DocElement.TagName);
      //if the element have HTML code add it to Child node
      if DocElement.innerHTML <> '' then
        TreeView1.Items.AddChild(TreeView1.Items.AddChild(ElementNode, 'HTML'), DocElement.innerHTML);
      //if the element have Text add it to Child node
      if DocElement.innerText <> '' then
        TreeView1.Items.AddChild(TreeView1.Items.AddChild(ElementNode, 'Text'), DocElement.innerText);
    end;
    //OK! UnLock TreeView
    TreeView1.Items.EndUpdate;
  except
    //If exception (it happend - no document, bad element...) Show the Exception message
    on E: Exception do
    begin
      memo1.Lines.Add('No Web Document Body Text');
      memo2.Lines.Add('No Web Document Body HTML');
      TreeView1.Items.Add(nil, 'No Web Document elements');
    end;
  end;
  //Hide 'Wait..." label
  Label5.Visible := false;
end;
//Tah all. Have a nice Web Browser's
end.

