//(copyleft) Denis Kirin, mailto:wtwsoft@yandex.ru
//GNU GPL
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OleCtrls, SHDocVw, ComCtrls, Masks, MSHTML_TLB;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    Splitter1: TSplitter;
    procedure Button1Click(Sender: TObject);
    procedure WebBrowser1TitleChange(Sender: TObject;
      const Text: WideString);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 WebBrowser1.Navigate(Edit1.Text);
end;

procedure TForm1.WebBrowser1TitleChange(Sender: TObject;
  const Text: WideString);
begin
 Caption := Text;
end;

procedure TForm1.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
 StatusBar1.SimpleText := Text;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then Button1.Click;
end;

procedure TForm1.WebBrowser1DocumentComplete(Sender: TObject;  const pDisp: IDispatch; var URL: OleVariant);
var
 WebBrowser: IWebBrowser2;
 Document: IHTMLDocument2;
 HTMLBody: IHTMLBodyElement;
 Body: IHTMLElement;
begin
//! Warning - the WebBrowser must hase complete document before you call they properties (like Document theirs RunTime)

//More variants how to do that
// Memo1.Text := OleVariant(pDisp).Document.Body.InnerText; //varinat 1 with using incomming pDisp interface
// Memo1.Text := OleVariant(WebBrowser1.Document).Body.InnerText; //varinat 2 with using TWebBrowser
// Variant 3 with use true interfaces from MSHTML_TLB
 // First we get interface to WebBrowser from pDisp
 pDisp.QueryInterface(IWebBrowser2, WebBrowser);
 WebBrowser.Document.QueryInterface(IHTMLDocument2, Document);
 //Look at Document properties it is more
 //So, we interested the Body interface, Body is ROOT element in DOM hierarchy
 //The Document is get Body interface as IHTMLElement, abstract DOM element (all standart properties)
 //but, we know we downalod true HTML page, so our Body element, the HTMLBodyElement
 Document.body.QueryInterface(IHTMLBodyElement, HTMLBody );
 //look at specific HTMLBody properties
 //but we use (for this sample) IHTMLElement
 Document.body.QueryInterface(IHTMLElement, Body );
 //now look at the Body as HTMLElement
 //just get text
 Memo1.Text := Body.innerText;
end;

end.
