//(copyleft) Denis Kirin, mailto:wtwsoft@yandex.ru
//GNU GPL
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OleCtrls, SHDocVw, ComCtrls, Masks, MSHTML_TLB;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure WebBrowser1TitleChange(Sender: TObject;
      const Text: WideString);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  WebBrowser1.Navigate(Edit1.Text);
end;

procedure TForm1.WebBrowser1TitleChange(Sender: TObject;
  const Text: WideString);
begin
  Caption := Text;
end;

procedure TForm1.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  StatusBar1.SimpleText := Text;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then Button1.Click;
end;

procedure TForm1.WebBrowser1DocumentComplete(Sender: TObject; const pDisp: IDispatch; var URL: OleVariant);
var
  WebBrowser: IWebBrowser2;
  Document: Variant;
  VariantElement: Variant;
  Form: Variant;
  FormCount, ElementCount: integer;
begin
//! Warning - the WebBrowser must hase complete document before you call they properties (like Document theirs RunTime)
  Memo1.Clear;
  pDisp.QueryInterface(IWebBrowser2, WebBrowser);
  Document := WebBrowser.Document;
 //enum all forms present on the downloaded WebDocument
  for FormCount := 0 to Document.Forms.length - 1 do
  begin
    Form := Document.Forms.Item(FormCount).elements;
      //enum input elements on the current form
    for ElementCount := 0 to Form.Length - 1 do
    begin
        //if the form element is SELECT element
        //see the IHTMLElement in MSHTML_TLB for the element properties and method help
        Memo1.Lines.add('Form: ' + Form.Name +
          ' element type: ' + Form.item(ElementCount).Type +
          ' name: ' + Form.item(ElementCount).Name +
          ' value: ' + Form.item(ElementCount).Value +
          ' text: ' + Form.item(ElementCount).innerText);
     end;
   end; 
end;
procedure TForm1.FormShow(Sender: TObject);
begin
  Edit1.Text := ExtractFileDir(ParamStr(0)) + '\template.htm';
  Button1.Click;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 ZeroVariant: OleVariant;
begin
 WebBrowser1DocumentComplete(Sender, WebBrowser1.DefaultInterface, ZeroVariant);
end;

end.

